#ifndef CCPUDEF_H
#define CCPUDEF_H

enum CCPUInstruction {
	InstNOP = 0x0,
	InstADD = 0x1,
	InstSUB = 0x2,
	InstMUL = 0x3,
	InstDIV = 0x4,
	InstJUMP = 0x5,
	InstCALL = 0x6,
	InstMOVE = 0x7,
	InstTE = 0x8,
	InstTL = 0x9,
	InstTLE = 0xA,
	InstIN = 0xB,
	InstOUT = 0xC,
	InstPUSH = 0xD,
	InstPOP = 0xE,
	InstCJ = 0xF
};

enum CCPUOperandCode {
	RegisterA = 0x0,
	RegisterB = 0x1,
	RegisterC = 0x2,
	RegisterIP = 0x3,
	RegisterSP = 0x4,
	RegisterFLAGS = 0x5,
	MemoryA = 0x6,
	MemoryB = 0x7,
	MemoryC = 0x8,
	MemorySP = 0x9,
	Constant = 0xA,
	MemoryConstant = 0xB,
	MemoryConstantPlusA = 0xC,
	MemoryConstantPlusIP = 0xD,
	MemoryConstantPlusSP = 0xE,
	MemoryBPlusA = 0xF
};

enum CCPUFlags {
	FlagTest = 0x0002,
	FlagOverflow = 0x0001
};

#endif
