#include <fstream>
#include <iostream>
#include <string>
#include <vector>

int main(int argc, char *argv[])
{
	std::vector<short> outputImage;

	argc--; argv++;

	std::string outputFilename=argv[0];

	argc--; argv++;

	do {
		int baseAddr=atoi(argv[0]);
		std::ifstream input(argv[1],std::ios::binary);
		if(!input) {
			std::cerr << "unable to open input file " << argv[1] << std::endl;
			return 1;
		}

		input.seekg(0,std::ios::end);
		unsigned int inputLength=input.tellg()/2;
		input.seekg(0,std::ios::beg);

		std::cout << argv[0] << "\t" << inputLength << "\t" << argv[1] << std::endl;

		if(outputImage.size()<baseAddr+inputLength) {
			outputImage.resize(baseAddr+inputLength);
		}

		input.read((char*)&outputImage[baseAddr],inputLength*sizeof(short));

		argc-=2; argv+=2;
	} while(argc>0);

	std::ofstream outputImageFile(outputFilename.c_str(),std::ios::binary);
	outputImageFile.write((char*)&outputImage[0],outputImage.size()*sizeof(short));

	return 0;
}
